---
title: Large-Allocation
slug: Web/HTTP/Headers/Large-Allocation
tags:
  - HTTP
  - HTTP Header
  - Non-standard
  - Reference
  - Response Header
  - header
---
<div>{{HTTPSidebar}}</div>

<p>The non-standard <strong><code>Large-Allocation</code></strong> response header tells the browser that the page being loaded is going to want to perform a large allocation. It is currently only implemented in Firefox, but is harmless to send to every browser.</p>

<p><a href="/en-US/docs/WebAssembly">WebAssembly</a> or asm.js applications can use large contiguous blocks of allocated memory. For complex games, for example, these allocations can be quite large, sometimes as large as 1GB. The <code>Large-Allocation</code> tells the browser that the web content in the to-be-loaded page is going to want to perform a large contiguous memory allocation and the browser can react to this header by starting a dedicated process for the to-be-loaded document, for example.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Large-Allocation: 0
Large-Allocation: &lt;megabytes&gt;
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code>0</code></dt>
 <dd>0 is a special value which represents uncertainty as to what the size of the allocation is.</dd>
 <dt><code>&lt;megabytes&gt;</code></dt>
 <dd>The expected size of the allocation to be performed, in megabytes.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre>Large-Allocation: 0
Large-Allocation: 500
</pre>

<h2 id="Troubleshooting_errors">Troubleshooting errors</h2>

<p>The <code>Large-Allocation</code> header throws warnings or error messages when used incorrectly. You'll encounter them in the <a href="/en-US/docs/Tools/Web_Console">web console</a>.</p>

<dl>
 <dt>This page was loaded in a new process due to a <code>Large-Allocation</code> header.</dt>
 <dd>This message means that the browser saw the <code>Large-Allocation</code> header, and was able to reload the page into a new process which should have more available contiguous memory.</dd>
 <dt>A <code>Large-Allocation</code> header was ignored due to the load being triggered by a non-GET request.</dt>
 <dd>When a {{HTTPMethod("POST")}} request is used to load a document, that load cannot currently be redirected into a new process. This error is displayed when loading a document with a <code>Large-Allocation</code> header with a non-GET HTTP method. This could be caused due to the document being loaded by a form submission, for example.</dd>
 <dt>A <code>Large-Allocation</code> header was ignored due to the presence of windows which have a reference to this browsing context through the frame hierarchy or {{domxref("window.opener")}}.</dt>
 <dd>
 <p>This error means that the document was not loaded at the top level of an user-opened or noopener-opened tab or window. It can occur in these situations:</p>

 <ul>
  <li>The document with the <code>Large-Allocation</code> header was loaded in an {{HTMLElement("iframe")}}. Firefox cannot move an iframe into a new process currently, so the document must load in the current process.</li>
  <li>The document with the <code>Large-Allocation</code> header was loaded in a window which was opened by {{domxref("window.open()")}}, <code>&lt;a target="_blank"&gt;</code> or other similar methods without <code>rel="noopener"</code> or the <code>"noopener"</code> feature being set. These windows must remain in the same process as their opener, as they can communicate, meaning that we cannot allow them to switch processes.</li>
  <li>The document with the <code>Large-Allocation header</code> has opened another window with {{domxref("window.open()")}}, <code>&lt;a target="_blank"&gt;</code> or other similar methods without <code>rel="noopener"</code> or the <code>"noopener"</code> feature being set. This is for the same reason as above, namely that they can communicate and thus we cannot allow them to switch processes.</li>
 </ul>
 </dd>
 <dt>A <code>Large-Allocation</code> header was ignored due to the document not being loaded out of process.</dt>
 <dd>Firefox has moved to a <a href="/en-US/docs/Mozilla/Firefox/Multiprocess_Firefox">multiprocess architecture</a>, and this architecture is required in order to support the <code>Large-Allocation</code> header. Some <a href="/en-US/docs/Mozilla/Add-ons/SDK">legacy Addons</a> can prevent Firefox from using this new, faster, multiprocess architecture. If you have one of these Addons installed, then we will continue to use the old single process architecuture for compatibility, and cannot handle the <code>Large-Allocation</code> header.</dd>
 <dt>This page would be loaded in a new process due to a <code>Large-Allocation</code> header, however <code>Large-Allocation</code> process creation is disabled on non-Win32 platforms.</dt>
 <dd>Firefox currently only supports the <code>Large-Allocation</code> header in our 32-bit Windows builds, as memory fragmentation is not an issue in 64-bit builds. If you are running a non-win32 version of Firefox, this error will appear. This check can be disabled with the "dom.largeAllocation.
 <p>forceEnable" boolean preferece in about:config.</p>
 </dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any current specifications. An explainer of the ideas behind this header can be found in <a href="https://gist.github.com/mystor/5739e222e398efc6c29108be55eb6fe3">this document</a>.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Large-Allocation")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a></li>
</ul>
